Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jgroups.protocols
Class FD_SOCK

    java.lang.Object
      org.jgroups.stack.Protocol
          org.jgroups.protocols.FD_SOCK

All Implemented Interfaces:
  java.lang.Runnable

    public class FD_SOCK

extends Protocol
implements java.lang.Runnable

Failure detection protocol based on sockets. Failure detection is ring-based. Each member creates a server socket and announces its address together with the server socket's address in a multicast. A pinger thread will be started when the membership goes above 1 and will be stopped when it drops below 2. The pinger thread connects to its neighbor on the right and waits until the socket is closed. When the socket is closed by the monitored peer in an abnormal fashion (IOException), the neighbor will be suspected.

The main feature of this protocol is that no ping messages need to be exchanged between any 2 peers, and failure detection relies entirely on TCP sockets. The advantage is that no activity will take place between 2 peers as long as they are alive (i.e. have their server sockets open). The disadvantage is that hung servers or crashed routers will not cause sockets to be closed, therefore they won't be detected. The FD_SOCK protocol will work for groups where members are on different hosts

The costs involved are 2 additional threads: one that monitors the client side of the socket connection (to monitor a peer) and another one that manages the server socket. However, those threads will be idle as long as both peers are running.

Author:
  Bela Ban May 29 2001

Nested Class Summary
`static class` | `FD_SOCK.FdHeader`

Field Summary
`protected java.lang.String` | `bind_interface_str`
`protected java.util.Set<Address>` | `suspected_mbrs`

Fields inherited from class org.jgroups.stack.Protocol
`down_prot, ergonomics, id, log, name, stack, stats, up_prot`

Constructor Summary
`FD_SOCK()`

Method Summary
`java.lang.Object` | `down(Event evt)` An event is to be sent down the stack.
`java.lang.String` | `getLocalAddress()`
`java.lang.String` | `getMembers()`
`int` | `getNumSuspectEventsGenerated()`
`java.lang.String` | `getPingableMembers()`
`java.lang.String` | `getPingDest()`
`void` | `init()` Called after instance has been created (null constructor) and before protocol is started.
`boolean` | `isLogSuspectedMessages()`
`java.lang.String` | `printCache()`
`java.lang.String` | `printSuspectHistory()`
`void` | `resetStats()`
`void` | `run()` Runs as long as there are 2 members and more.
`void` | `setLogSuspectedMessages(boolean log_suspected_msgs)`
`void` | `start()` This method is called on a `Channel.connect(String)`.
`void` | `stop()` This method is called on a `Channel.disconnect()`.
`void` | `stopServerSocket(boolean graceful)`
`java.lang.Object` | `up(Event evt)` An event was received from the layer below.

Methods inherited from class org.jgroups.stack.Protocol
`destroy, downThreadEnabled, dumpStats, enableStats, getConfigurableObjects, getDownProtocol, getId, getLevel, getName, getProperties, getProtocolStack, getSocketFactory, getThreadFactory, getTransport, getUpProtocol, getValue, isErgonomics, printStats, providedDownServices, providedUpServices, requiredDownServices, requiredUpServices, setDownProtocol, setErgonomics, setId, setLevel, setProperties, setPropertiesInternal, setProperty, setProtocolStack, setSocketFactory, setUpProtocol, setValue, setValues, statsEnabled, upThreadEnabled`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### bind_interface_str

    protected java.lang.String bind_interface_str

### suspected_mbrs

    protected final java.util.Set<Address> suspected_mbrs

Constructor Detail

### FD_SOCK

    public FD_SOCK()

Method Detail

### getLocalAddress

    public java.lang.String getLocalAddress()

### getMembers

    public java.lang.String getMembers()

### getPingableMembers

    public java.lang.String getPingableMembers()

### getPingDest

    public java.lang.String getPingDest()

### getNumSuspectEventsGenerated

    public int getNumSuspectEventsGenerated()

### isLogSuspectedMessages

    public boolean isLogSuspectedMessages()

### setLogSuspectedMessages

    public void setLogSuspectedMessages(boolean log_suspected_msgs)

### printSuspectHistory

    public java.lang.String printSuspectHistory()

### printCache

    public java.lang.String printCache()

### init

    public void init()
              throws java.lang.Exception

  Description copied from class: `Protocol`
  Called after instance has been created (null constructor) and before protocol is started. Properties are already set. Other protocols are not yet connected and events cannot yet be sent.

  Overrides:
    `init` in class `Protocol`
  Throws:
    `java.lang.Exception` - Thrown if protocol cannot be initialized successfully. This will cause the ProtocolStack to fail, so the channel constructor will throw an exception

### start

    public void start()
               throws java.lang.Exception

  Description copied from class: `Protocol`
  This method is called on a `Channel.connect(String)`. Starts work. Protocols are connected and queues are ready to receive events. Will be called from bottom to top. This call will replace the START and START_OK events.

  Overrides:
    `start` in class `Protocol`
  Throws:
    `java.lang.Exception` - Thrown if protocol cannot be started successfully. This will cause the ProtocolStack to fail, so `Channel.connect(String)` will throw an exception

### stop

    public void stop()

  Description copied from class: `Protocol`
  This method is called on a `Channel.disconnect()`. Stops work (e.g. by closing multicast socket). Will be called from top to bottom. This means that at the time of the method invocation the neighbor protocol below is still working. This method will replace the STOP, STOP_OK, CLEANUP and CLEANUP_OK events. The ProtocolStack guarantees that when this method is called all messages in the down queue will have been flushed

  Overrides:
    `stop` in class `Protocol`

### resetStats

    public void resetStats()

  Overrides:
    `resetStats` in class `Protocol`

### up

    public java.lang.Object up(Event evt)

  Description copied from class: `Protocol`
  An event was received from the layer below. Usually the current layer will want to examine the event type and - depending on its type - perform some computation (e.g. removing headers from a MSG event type, or updating the internal membership list when receiving a VIEW_CHANGE event). Finally the event is either a) discarded, or b) an event is sent down the stack using `down_prot.down()` or c) the event (or another event) is sent up the stack using `up_prot.up()`.

  Overrides:
    `up` in class `Protocol`

### down

    public java.lang.Object down(Event evt)

  Description copied from class: `Protocol`
  An event is to be sent down the stack. The layer may want to examine its type and perform some action on it, depending on the event's type. If the event is a message MSG, then the layer may need to add a header to it (or do nothing at all) before sending it down the stack using `down_prot.down()`. In case of a GET_ADDRESS event (which tries to retrieve the stack's address from one of the bottom layers), the layer may need to send a new response event back up the stack using `up_prot.up()`.

  Overrides:
    `down` in class `Protocol`

### run

    public void run()

  Runs as long as there are 2 members and more. Determines the member to be monitored and fetches its server socket address (if n/a, sends a message to obtain it). The creates a client socket and listens on it until the connection breaks. If it breaks, emits a SUSPECT message. It the connection is closed regularly, nothing happens. In both cases, a new member to be monitored will be chosen and monitoring continues (unless there are fewer than 2 members).

  Specified by:
    `run` in interface `java.lang.Runnable`

### stopServerSocket

    public void stopServerSocket(boolean graceful)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1998-2009 Bela Ban / Red Hat. All Rights Reserved.